// JavaScript Ignite Slide Presentation software.
//
// Copyright 2009 by Akkana Peck.
// This software is licensed under the GNU public license v.2 or later --
// Please share and enjoy!

// See a presentation on how to use this at
// http://shallowsky.com/software/ignite-js/
// (once I make it)

///////////////////////////////////////////////////////////////
//
// Slide navigation. List your slides here, in order.
//
var slides = new Array ( "title.html",
                         "ignite.html",
                         "auto-advance.html",
                         "shorter.html",
                         "this-js.html",
                         "options.html",
                         "css.html",
                         "html.html",
                         "not-real.html",
                         "last.html"
                         );

var secPerSlide = 10;  // 15 for a real Ignite talk
var countdown = true;
//
// end variables section.
// You shouldn't have to change anything after this.
//
///////////////////////////////////////////////////////////////

function indexOfPage() {
  var url = document.URL;
  var lastslash = document.URL.lastIndexOf("/");
  var filename = url.substring(lastslash+1, url.length);

  // JS 1.6 has Array.indexOf, but that doesn't work in Opera/Konq/etc.
  if (slides.indexOf) return slides.indexOf(filename);
  var i;
  for (i=0; i<slides.length; ++i) {
    if (slides[i] == filename) return i;
  }
  return 0;
}

var curSlide= indexOfPage();
var countdownSecs = (slides.length - curSlide) * secPerSlide;
var countdown_txt;

function nextSlide() {
  //alert("nextSlide: " + (curSlide+1));
  document.location = slides[curSlide+1];
}

function updateCountdownText() {
  var mins = Math.floor(countdownSecs / 60)
  var secs = countdownSecs % 60
  if (secs < 10) secs = "0" + secs;
  countdown_txt.nodeValue = "" + mins + ":" + secs;
}

function updateTime() {
  countdownSecs -= 1;
  updateCountdownText();
  if (countdownSecs > 0)
    setTimeout("updateTime();", 1000);
}

// We're currently on slide # whichslide.
// Next will be whichslide+1.

if (countdown) {
  setTimeout("updateTime();", 1000);
}

if ((curSlide+1) < slides.length) {
  setTimeout("nextSlide();", secPerSlide * 1000);
}
//else alert("Last slide: " + (curSlide+1) + " of " + slides.length);

var page = document.getElementById("page");
//alert("Page:" + page);

// Now add the slide number
var slideno_span = document.createElement("span");
slideno_span.setAttribute("id", "slideno");
page.appendChild(slideno_span);
var slideno_txt = document.createTextNode("[Slide " + (curSlide+1)
                                          + "/" + slides.length + "]");
slideno_span.appendChild(slideno_txt);

// and the countdown
if (countdown) {
  var countdown_span = document.createElement("span");
  countdown_span.setAttribute("id", "countdown");
  document.body.appendChild(countdown_span);
  countdown_txt = document.createTextNode("");
  countdown_span.appendChild(countdown_txt);
  updateCountdownText();
}

